(* 
 * Copyright (c) 2001, 2002 The University of Wroclaw.
 * All rights reserved. See file COPYRIGHT for details about licensing.
 *
 * $Id: gontcodegen.mli,v 1.3 2002/02/16 12:09:08 malekith Exp $
 *
 * Module interface: Gontcodegen
 * Description:
 *)

open Gonttree

type ctx

(* Initialize code generator for named module and input file. *)
val init_codegen : (* module *) string -> (* file *) string -> ctx

(* This needs to be called right after init_codegen, to make prototypes
 * of runtime environment. Declaration list needs to be output. *)
val ksi_runtime_proto : ctx -> Ksi.decl list

(* Convert given declaration to list of Ksi declaration to be output. 
 * Also returns updated context. *)
val ksi_code : ctx -> decl -> ctx * (Ksi.decl list)

(* Checks whatever compiled module is complete. To be called at the
 * end of compilation of module. *)
val check_module : ctx -> unit
;;
